/*
 * add_list.s
 *
 *  Created on: 22/mar/2016
 *      Author: fb
 */


.global add_list

/*
 * int add_list(int*, int);
 *
 * Application Binary Interface:
 * 		Parameters passed in registers: R4 and R5
 *			R4 contains the address of the first integer to be added
 *			R5 contains the number of integers to be added
 *		Result must be in register R2
 *
*/

add_list:

	add r2, zero, zero			/* clear R2, R2 uses as accumulator register */
loop:
								/* R8 is a caller-saved register, no need to be saved and restored */
	ldw r8, (r4)				/* load in R8 the integer to be added */
	add r2, r2, r8
	addi r4, r4, 4
	subi r5, r5, 1
	bgt r5, zero, loop

	ret
