/*
 * test_add_list.c
 *
 *  Created on: 22/mar/2016
 *      Author: fb
 *
 *
 */

#include "system.h"

// Macros for I/O register access
#define HEX3_HEX0	(* (volatile unsigned int*) HEX3_HEX0_BASE)

// Global variables
#define NUM 10
int vec[NUM];

// Function prototypes
int add_list(int*, int);		// implemented in add_list.s
unsigned int HexToSevenSeg(unsigned int hex);

unsigned int HexToSevenSeg(unsigned int hex)
{
	const unsigned char LUT_HEX_TO_SEVEN_SEG[16] = {
	    0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x67, /* 0-9 */
	    0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71 };                       /* A,b,C,d,E,F */

	unsigned int data = LUT_HEX_TO_SEVEN_SEG[hex        & 15]        |
			           (LUT_HEX_TO_SEVEN_SEG[(hex >> 4) & 15] <<  8) |
			           (LUT_HEX_TO_SEVEN_SEG[(hex >> 8) & 15] << 16) |
			           (LUT_HEX_TO_SEVEN_SEG[(hex >>12) & 15] << 24);

   return data;
}


int main() {

	int i, res;

	/* Initialize the vec with numbers from 1 to NUM */
	for(i=0; i<NUM; i++) {

		vec[i] = i+1;
	}
	/* Call the add_list function */
	res = add_list(&vec[0], NUM);

	/* Display the sum on the HEX3_HEX0 as hex digits */
	HEX3_HEX0 = ~HexToSevenSeg(res);

	/* Go to the infinite loop */
	return 0;

}
